// hlavickove subory *******************************************************
#include "../includes.h"
// vlastny .h subor
#include "enviro.h"

// konstruktor *************************************************************
CEnviro::CEnviro()
{
 // identifikatory textur
 loopi(6) tex[i]=0;
}

// destruktor **************************************************************
CEnviro::~CEnviro()
{
 glDeleteBuffers(1,&v_buf);
 glDeleteBuffers(1,&t_buf);
 glDeleteBuffers(1,&tbn_t_buf);
 glDeleteBuffers(1,&tbn_b_buf);
 glDeleteBuffers(1,&tbn_n_buf);

 // Vertex Array Object
 glDeleteVertexArrays(1,&vao);
}

// vypocet TBN *************************************************************
void CEnviro::get_tbn(int V,int T)
{
 // vypocet TBN
 vec3 v0,v1,v2;
 vec2 t0,t1,t2;
 // pre 1. trojuholnik
 //           . v2
 //         . .
 //       .   .
 //     .     .
 // v0 ........ v1
 v0.set(v[V],v[V+1],v[V+2]); v1.set(v[V+3],v[V+4],v[V+5]); v2.set(v[V+6],v[V+7],v[V+8]);
 t0.set(t[T],t[T+1]); t1.set(t[T+2],t[T+3]); t2.set(t[T+4],t[T+5]);
 mm.calc_tbn(v0,v1,v2,t0,t1,t2,tan,bit,nor); // vypocet TBN
 tbn_t[V]=tan.x;   tbn_t[V+1]=tan.y; tbn_t[V+2]=tan.z;
 tbn_t[V+3]=tan.x; tbn_t[V+4]=tan.y; tbn_t[V+5]=tan.z;
 tbn_t[V+6]=tan.x; tbn_t[V+7]=tan.y; tbn_t[V+8]=tan.z;
 tbn_b[V]=bit.x;   tbn_b[V+1]=bit.y; tbn_b[V+2]=bit.z;
 tbn_b[V+3]=bit.x; tbn_b[V+4]=bit.y; tbn_b[V+5]=bit.z;
 tbn_b[V+6]=bit.x; tbn_b[V+7]=bit.y; tbn_b[V+8]=bit.z;
 tbn_n[V]=nor.x;   tbn_n[V+1]=nor.y; tbn_n[V+2]=nor.z;
 tbn_n[V+3]=nor.x; tbn_n[V+4]=nor.y; tbn_n[V+5]=nor.z;
 tbn_n[V+6]=nor.x; tbn_n[V+7]=nor.y; tbn_n[V+8]=nor.z;
 // pre 2. trojuholnik
 // v2 ........ v1
 //    .     .
 //    .   .
 //    . .
 // v0 .
 v0.set(v[V+9],v[V+10],v[V+11]); v1.set(v[V+12],v[V+13],v[V+14]); v2.set(v[V+15],v[V+16],v[V+17]);
 t0.set(t[T+6],t[T+7]); t1.set(t[T+8],t[T+9]); t2.set(t[T+10],t[T+11]);
 mm.calc_tbn(v0,v1,v2,t0,t1,t2,tan,bit,nor); // vypocet TBN
 tbn_t[V+9]=tan.x;  tbn_t[V+10]=tan.y; tbn_t[V+11]=tan.z;
 tbn_t[V+12]=tan.x; tbn_t[V+13]=tan.y; tbn_t[V+14]=tan.z;
 tbn_t[V+15]=tan.x; tbn_t[V+16]=tan.y; tbn_t[V+17]=tan.z;
 tbn_b[V+9]=bit.x;  tbn_b[V+10]=bit.y; tbn_b[V+11]=bit.z;
 tbn_b[V+12]=bit.x; tbn_b[V+13]=bit.y; tbn_b[V+14]=bit.z;
 tbn_b[V+15]=bit.x; tbn_b[V+16]=bit.y; tbn_b[V+17]=bit.z;
 tbn_n[V+9]=nor.x;  tbn_n[V+10]=nor.y; tbn_n[V+11]=nor.z;
 tbn_n[V+12]=nor.x; tbn_n[V+13]=nor.y; tbn_n[V+14]=nor.z;
 tbn_n[V+15]=nor.x; tbn_n[V+16]=nor.y; tbn_n[V+17]=nor.z;
}

// inicializacia objektu predstavujuceho okolite prostredie ****************
int CEnviro::init(void)
{
 loopi(6) tex[i]=20+i; // podla CubeMap textury (interface.cpp)

 int k=0,l=0;
 v[k]=200.0f; v[k+1]=200.0f; v[k+2]=200.0f; v[k+3]=200.0f; v[k+4]=200.0f; v[k+5]=-200.0f;
 v[k+6]=200.0f; v[k+7]=-200.0f; v[k+8]=-200.0f;
 v[k+9]=200.0f; v[k+10]=200.0f; v[k+11]=200.0f; v[k+12]=200.0f; v[k+13]=-200.0f; v[k+14]=-200.0f;
 v[k+15]=200.0f; v[k+16]=-200.0f; v[k+17]=200.0f;
 t[l]=0.0f; t[l+1]=0.0f; t[l+2]=1.0f; t[l+3]=0.0f; t[l+4]=1.0f; t[l+5]=1.0f;
 t[l+6]=0.0f; t[l+7]=0.0f; t[l+8]=1.0f; t[l+9]=1.0f; t[l+10]=0.0f; t[l+11]=1.0f;
 get_tbn(k,l);
 k+=18; l+=12;
 v[k]=-200.0f; v[k+1]=200.0f; v[k+2]=-200.0f; v[k+3]=-200.0f; v[k+4]=200.0f; v[k+5]=200.0f;
 v[k+6]=-200.0f; v[k+7]=-200.0f; v[k+8]=200.0f;
 v[k+9]=-200.0f; v[k+10]=200.0f; v[k+11]=-200.0f; v[k+12]=-200.0f; v[k+13]=-200.0f; v[k+14]=200.0f;
 v[k+15]=-200.0f; v[k+16]=-200.0f; v[k+17]=-200.0f;
 t[l]=0.0f; t[l+1]=0.0f; t[l+2]=1.0f; t[l+3]=0.0f; t[l+4]=1.0f; t[l+5]=1.0f;
 t[l+6]=0.0f; t[l+7]=0.0f; t[l+8]=1.0f; t[l+9]=1.0f; t[l+10]=0.0f; t[l+11]=1.0f;
 get_tbn(k,l);
 k+=18; l+=12;
 v[k]=-200.0f; v[k+1]=200.0f; v[k+2]=-200.0f; v[k+3]=200.0f; v[k+4]=200.0f; v[k+5]=-200.0f;
 v[k+6]=200.0f; v[k+7]=200.0f; v[k+8]=200.0f;
 v[k+9]=-200.0f; v[k+10]=200.0f; v[k+11]=-200.0f; v[k+12]=200.0f; v[k+13]=200.0f; v[k+14]=200.0f;
 v[k+15]=-200.0f; v[k+16]=200.0f; v[k+17]=200.0f;
 t[l]=0.0f; t[l+1]=0.0f; t[l+2]=1.0f; t[l+3]=0.0f; t[l+4]=1.0f; t[l+5]=1.0f;
 t[l+6]=0.0f; t[l+7]=0.0f; t[l+8]=1.0f; t[l+9]=1.0f; t[l+10]=0.0f; t[l+11]=1.0f;
 get_tbn(k,l);
 k+=18; l+=12;
 v[k]=-200.0f; v[k+1]=-200.0f; v[k+2]=200.0f; v[k+3]=200.0f; v[k+4]=-200.0f; v[k+5]=200.0f;
 v[k+6]=200.0f; v[k+7]=-200.0f; v[k+8]=-200.0f;
 v[k+9]=-200.0f; v[k+10]=-200.0f; v[k+11]=200.0f; v[k+12]=200.0f; v[k+13]=-200.0f; v[k+14]=-200.0f;
 v[k+15]=-200.0f; v[k+16]=-200.0f; v[k+17]=-200.0f;
 t[l]=0.0f; t[l+1]=0.0f; t[l+2]=1.0f; t[l+3]=0.0f; t[l+4]=1.0f; t[l+5]=1.0f;
 t[l+6]=0.0f; t[l+7]=0.0f; t[l+8]=1.0f; t[l+9]=1.0f; t[l+10]=0.0f; t[l+11]=1.0f;
 get_tbn(k,l);
 k+=18; l+=12;
 v[k]=-200.0f; v[k+1]=200.0f; v[k+2]=200.0f; v[k+3]=200.0f; v[k+4]=200.0f; v[k+5]=200.0f;
 v[k+6]=200.0f; v[k+7]=-200.0f; v[k+8]=200.0f;
 v[k+9]=-200.0f; v[k+10]=200.0f; v[k+11]=200.0f; v[k+12]=200.0f; v[k+13]=-200.0f; v[k+14]=200.0f;
 v[k+15]=-200.0f; v[k+16]=-200.0f; v[k+17]=200.0f;
 t[l]=0.0f; t[l+1]=0.0f; t[l+2]=1.0f; t[l+3]=0.0f; t[l+4]=1.0f; t[l+5]=1.0f;
 t[l+6]=0.0f; t[l+7]=0.0f; t[l+8]=1.0f; t[l+9]=1.0f; t[l+10]=0.0f; t[l+11]=1.0f;
 get_tbn(k,l);
 k+=18; l+=12;
 v[k]=200.0f; v[k+1]=200.0f; v[k+2]=-200.0f; v[k+3]=-200.0f; v[k+4]=200.0f; v[k+5]=-200.0f;
 v[k+6]=-200.0f; v[k+7]=-200.0f; v[k+8]=-200.0f;
 v[k+9]=200.0f; v[k+10]=200.0f; v[k+11]=-200.0f; v[k+12]=-200.0f; v[k+13]=-200.0f; v[k+14]=-200.0f;
 v[k+15]=200.0f; v[k+16]=-200.0f; v[k+17]=-200.0f;
 t[l]=0.0f; t[l+1]=0.0f; t[l+2]=1.0f; t[l+3]=0.0f; t[l+4]=1.0f; t[l+5]=1.0f;
 t[l+6]=0.0f; t[l+7]=0.0f; t[l+8]=1.0f; t[l+9]=1.0f; t[l+10]=0.0f; t[l+11]=1.0f;
 get_tbn(k,l);

 // Vertex Array Object
 glGenVertexArrays(1,&vao);
 glBindVertexArray(vao);

 glGenBuffers(1,&v_buf);
 glBindBuffer(GL_ARRAY_BUFFER,v_buf);
 glBufferData(GL_ARRAY_BUFFER,sizeof(v),v,GL_STATIC_DRAW);
 // vrcholy
 glVertexAttribPointer(0,3,GL_FLOAT,GL_FALSE,0,0);
 glGenBuffers(1,&t_buf);
 glBindBuffer(GL_ARRAY_BUFFER,t_buf);
 glBufferData(GL_ARRAY_BUFFER,sizeof(t),t,GL_STATIC_DRAW);
 // texturovacie suradnice
 glVertexAttribPointer(8,2,GL_FLOAT,GL_FALSE,0,0);
 // T
 glGenBuffers(1,&tbn_t_buf);
 glBindBuffer(GL_ARRAY_BUFFER,tbn_t_buf);
 glBufferData(GL_ARRAY_BUFFER,sizeof(tbn_t),tbn_t,GL_STATIC_DRAW);
 glVertexAttribPointer(2,3,GL_FLOAT,GL_FALSE,0,0);
 // B
 glGenBuffers(1,&tbn_b_buf);
 glBindBuffer(GL_ARRAY_BUFFER,tbn_b_buf);
 glBufferData(GL_ARRAY_BUFFER,sizeof(tbn_b),tbn_b,GL_STATIC_DRAW);
 glVertexAttribPointer(3,3,GL_FLOAT,GL_FALSE,0,0);
 // N
 glGenBuffers(1,&tbn_n_buf);
 glBindBuffer(GL_ARRAY_BUFFER,tbn_n_buf);
 glBufferData(GL_ARRAY_BUFFER,sizeof(tbn_n),tbn_n,GL_STATIC_DRAW);
 glVertexAttribPointer(4,3,GL_FLOAT,GL_FALSE,0,0);

 glEnableVertexAttribArray(0);
 glEnableVertexAttribArray(2);
 glEnableVertexAttribArray(3);
 glEnableVertexAttribArray(4);
 glEnableVertexAttribArray(8);

 glBindVertexArray(0);

 return(0);
}

// vykreslenie objektu predstavujuceho okolite prostredie ******************
void CEnviro::draw(void)
{
 glBindVertexArray(vao);

 loopi(6) {
  glBindTexture(GL_TEXTURE_2D,texture.tex_id[tex[i]]);
  glDrawArrays(GL_TRIANGLES,i*6,6);
 }

 glBindVertexArray(0);
}
