#version 130 // GLSL verzia

uniform sampler2D base_tex_unit;   // color
uniform sampler2D deltas_tex_unit; // deltas
uniform int msaa_smp;              // MSAA samples
uniform vec2 dxdy;                 // delta dvoch susediacich texturovacich suradnic
uniform float fps_correction;      // mblur efekt je zavisly na FPS

// vstup z vertex shadera
in vec2 uv; // texturovacie suradnice

float deltap; // pohybovy vektor vyjadreny v bodoch
int smp;      // pocet vzoriek

void main(void)
{
 vec4 color=vec4(0.0);
/*
 for (int y=0;y<msaa_smp;y++) {
  for (int x=0;x<msaa_smp;x++) {
   // farba fragmentu ulozena v 2D texture
   color+=texture(base_tex_unit,uv+vec2(x*dxdy.x,y*dxdy.y));
  }
 }
 color/=(msaa_smp*msaa_smp);
*/
 // pohybovy vektor
 vec4 deltas=texture(deltas_tex_unit,uv);

 // cim viac snimkov za sekundu (FPS) tym viac vzoriek pre mblur
 deltas*=fps_correction;

 // transformacia pohyboveho vektora na jeho vyjadrenie v bodoch
 deltap=length(deltas.xy/vec2(1.0/800.0,1.0/600.0));

 // pocet vzoriek zavisly na velkosti pohyboveho vektora
 smp=clamp(int(deltap),2,10);

 // mblur funkcia
 for (int i=1;i<=smp;i++) {
  // scitanie farieb daneho poctu vzoriek nachadzajucich
  // sa v <-0.5;0.5> okoli tych fragmentov, ktore maju v texture
  // ulozene nenulove pohybove vektory
  color+=texture(base_tex_unit,uv+deltas.xy*(float(i)/float(smp)-0.5));
 }
 color/=float(smp);

 // vysledna farba
 gl_FragColor=color;
}
